//  Author: Boroda
//  Date:02.07.2016
//
/*******************************************************************************/
#include "TM1637m2.h"
#include <Arduino.h>
static byte TubeTab[] = {0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x77,0x7c,
                           0x39,0x5e,0x79,0x71,0x3D,0x76,0x06,0x1E,0x75,0x38,0x55,0x54,
						   0x3F,0x73,0xBF,0x50,0x6D,0x78,0x3E,0x3E,0x6A,0x76,0x6E,0x5B,
						   0x58,0x74,0x04,0x0C,0x18,0x5C,0x67,0x1C,0x7D,0x31,0x37,0x54,
						   0x00,0x39,0x0F,0x48,0x53,0x5F,0x22,0x14,0x52,0x64,0x02,0x02,
						   0x63,0x80,0x40,0x01,0x08,0x58,0x4C,0x61,0x62,0x43,0x23,0x41};//Знакогенератор 
						                          
TM1637::TM1637(byte Clk, byte Data)
{
  Clkpin = Clk;
  Datapin = Data;
  pinMode(Clkpin,OUTPUT);
  pinMode(Datapin,OUTPUT);
}
// передаем 8 бит
void TM1637::writeByte(byte wr_data)
{
  byte i,count1;   
  for(i=0;i<8;i++)        
  {
    digitalWrite(Clkpin,LOW);      
    if(wr_data & 0x01)digitalWrite(Datapin,HIGH);//младшим байтом первый
    else digitalWrite(Datapin,LOW);
    wr_data >>= 1;      
    digitalWrite(Clkpin,HIGH);
      
  }  
  digitalWrite(Clkpin,LOW); // ждем подтверждения ACK
  digitalWrite(Datapin,HIGH);
  digitalWrite(Clkpin,HIGH);     
  pinMode(Datapin,INPUT);
  while(digitalRead(Datapin))    
  { 
    count1 +=1;
    if(count1 == 200)//
    {
     pinMode(Datapin,OUTPUT);
     digitalWrite(Datapin,LOW);
     count1 =0;
    }
    pinMode(Datapin,INPUT);
  }
  pinMode(Datapin,OUTPUT);
  
}
// Сигнал старт TM1637
void TM1637::start(void)
{
  digitalWrite(Clkpin,HIGH);//send start signal to TM1637
  digitalWrite(Datapin,HIGH); 
  digitalWrite(Datapin,LOW); 
  digitalWrite(Clkpin,LOW); 
} 
// Сигнал стоп TM1637
void TM1637::stop(void)
{
  digitalWrite(Clkpin,LOW);
  digitalWrite(Datapin,LOW);
  digitalWrite(Clkpin,HIGH);
  digitalWrite(Datapin,HIGH); 
}
// Записываем данные в дисплей
void TM1637::display(byte DispData[],byte PointPos,byte Brightness)
{
  byte i;
  start();          		// Сигнал старт TM1637
  writeByte(0x40);			// Отправляем команду 0x40 (запись в дисплей 00)
  stop();           		// Сигнал стоп TM1637
  start();          		// Сигнал старт TM1637
  writeByte(0xc0);			// Отправляем адрес начальной ячейки памяти 0xc0 (00)
  for(i=0;i < 4;i ++)
  {
    DispData[i] = TubeTab[DispData[i]] + (0x80 * (bitRead(PointPos,i))); // Преобразуем данные для индикатора
	writeByte(DispData[i]); // Отправляем на индикатор
  }
  stop();           // Сигнал стоп TM1637
  start();          // Сигнал старт TM1637
  Cmd_DispCtrl = 0x88 + Brightness;//Установка яркости дисплея
  writeByte(Cmd_DispCtrl);// Отправляем яркость
  stop();           //
}





